/* WindowControl.c generated by valac 0.26.1, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <string.h>


#define PLANK_SERVICES_WINDOWS_TYPE_STRUTS (plank_services_windows_struts_get_type ())

#define PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL (plank_services_windows_window_control_get_type ())
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))

typedef struct _PlankServicesWindowsWindowControl PlankServicesWindowsWindowControl;
typedef struct _PlankServicesWindowsWindowControlClass PlankServicesWindowsWindowControlClass;
typedef struct _PlankServicesWindowsWindowControlPrivate PlankServicesWindowsWindowControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

typedef enum  {
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_START,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_END,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END,
	PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES
} PlankServicesWindowsStruts;

struct _PlankServicesWindowsWindowControl {
	GObject parent_instance;
	PlankServicesWindowsWindowControlPrivate * priv;
};

struct _PlankServicesWindowsWindowControlClass {
	GObjectClass parent_class;
};


static gpointer plank_services_windows_window_control_parent_class = NULL;
static guint plank_services_windows_window_control_delayed_focus_timer;
static guint plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
static WnckWindow* plank_services_windows_window_control_delayed_focus_window;
static WnckWindow* plank_services_windows_window_control_delayed_focus_window = NULL;

GType plank_services_windows_struts_get_type (void) G_GNUC_CONST;
GType plank_services_windows_window_control_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_DUMMY_PROPERTY
};
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY ((guint) 10000)
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY ((guint) 200)
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void);
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type);
void plank_services_windows_window_control_initialize (void);
static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self);
static void plank_services_windows_window_control_handle_window_closed (WnckWindow* window);
static void _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window);
guint plank_services_windows_window_control_get_num_windows (BamfApplication* app);
gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace);
void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect);
void plank_services_windows_window_control_close_all (BamfApplication* app);
void plank_services_windows_window_control_focus_window (BamfWindow* window);
static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w);
static void plank_services_windows_window_control_focus_window_by_xid (guint32 xid);
static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids);
void plank_services_windows_window_control_focus_previous (BamfApplication* app);
void plank_services_windows_window_control_focus_next (BamfApplication* app);
void plank_services_windows_window_control_minimize (BamfApplication* app);
GList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app);
void plank_services_windows_window_control_restore (BamfApplication* app);
void plank_services_windows_window_control_maximize (BamfApplication* app);
void plank_services_windows_window_control_unmaximize (BamfApplication* app);
void plank_services_windows_window_control_smart_focus (BamfApplication* app);
static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows);
static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second);
static gboolean __lambda4_ (void);
static gboolean ___lambda4__gsource_func (gpointer self);
void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result);
static void plank_services_windows_window_control_finalize (GObject* obj);


GType plank_services_windows_struts_get_type (void) {
	static volatile gsize plank_services_windows_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_WINDOWS_STRUTS_LEFT, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT", "left"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT", "right"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP, "PLANK_SERVICES_WINDOWS_STRUTS_TOP", "top"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM", "bottom"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START", "left-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END", "left-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START", "right-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END", "right-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_START, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_START", "top-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_END, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_END", "top-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES, "PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_services_windows_struts_type_id;
		plank_services_windows_struts_type_id = g_enum_register_static ("PlankServicesWindowsStruts", values);
		g_once_init_leave (&plank_services_windows_struts_type_id__volatile, plank_services_windows_struts_type_id);
	}
	return plank_services_windows_struts_type_id__volatile;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type) {
	PlankServicesWindowsWindowControl * self = NULL;
	self = (PlankServicesWindowsWindowControl*) g_object_new (object_type, NULL);
	return self;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void) {
	return plank_services_windows_window_control_construct (PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL);
}


static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self) {
	plank_services_windows_window_control_window_manager_changed (_sender);
}


static void _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	plank_services_windows_window_control_handle_window_closed (window);
}


void plank_services_windows_window_control_initialize (void) {
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	_tmp0_ = wnck_screen_get_default ();
	screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	wnck_screen_force_update (screen);
	g_signal_connect_after (screen, "window-manager-changed", (GCallback) _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
	g_signal_connect_after (screen, "window-closed", (GCallback) _plank_services_windows_window_control_handle_window_closed_wnck_screen_window_closed, NULL);
	_tmp1_ = wnck_screen_get_window_manager_name (screen);
	g_message ("WindowControl.vala:62: Window-manager: %s", _tmp1_);
}


static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen) {
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	wnck_screen_force_update (_tmp0_);
	_tmp1_ = screen;
	_tmp2_ = wnck_screen_get_window_manager_name (_tmp1_);
	g_warning ("WindowControl.vala:70: Window-manager changed: %s", _tmp2_);
}


static void plank_services_windows_window_control_handle_window_closed (WnckWindow* window) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	g_return_if_fail (window != NULL);
	_tmp1_ = plank_services_windows_window_control_delayed_focus_timer;
	if (_tmp1_ > ((guint) 0)) {
		WnckWindow* _tmp2_ = NULL;
		WnckWindow* _tmp3_ = NULL;
		_tmp2_ = plank_services_windows_window_control_delayed_focus_window;
		_tmp3_ = window;
		_tmp0_ = _tmp2_ == _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		guint _tmp4_ = 0U;
		_tmp4_ = plank_services_windows_window_control_delayed_focus_timer;
		g_source_remove (_tmp4_);
		plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
		_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
		plank_services_windows_window_control_delayed_focus_window = NULL;
	}
}


GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GdkPixbuf* _tmp19_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	pbuf = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					GdkPixbuf* _tmp11_ = NULL;
					_tmp11_ = pbuf;
					_tmp5_ = _tmp11_ == NULL;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp16_ = window;
				if (_tmp16_ != NULL) {
					WnckWindow* _tmp17_ = NULL;
					GdkPixbuf* _tmp18_ = NULL;
					_tmp17_ = window;
					_tmp18_ = wnck_window_get_icon (_tmp17_);
					pbuf = _tmp18_;
				}
			}
		}
	}
	_tmp19_ = pbuf;
	result = _tmp19_;
	_g_array_unref0 (xids);
	return result;
}


GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window) {
	GdkPixbuf* result = NULL;
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp5_ = w;
	_tmp6_ = wnck_window_get_icon (_tmp5_);
	result = _tmp6_;
	return result;
}


guint plank_services_windows_window_control_get_num_windows (BamfApplication* app) {
	guint result = 0U;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	guint count = 0U;
	g_return_val_if_fail (app != NULL, 0U);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	count = (guint) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					WnckWindow* _tmp17_ = NULL;
					_tmp16_ = window;
					_tmp17_ = wnck_window_get_transient (_tmp16_);
					_tmp14_ = _tmp17_ == NULL;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					guint _tmp18_ = 0U;
					_tmp18_ = count;
					count = _tmp18_ + 1;
				}
			}
		}
	}
	result = count;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_maximized (_tmp16_);
					_tmp14_ = _tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_minimized (_tmp16_);
					_tmp14_ = _tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	gboolean is_virtual = FALSE;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (app != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = workspace;
	_tmp4_ = wnck_workspace_is_virtual (_tmp3_);
	is_virtual = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp7_ = FALSE;
				GArray* _tmp8_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				if (!_tmp5_) {
					gint _tmp6_ = 0;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = xids;
				if (_tmp8_ != NULL) {
					gint _tmp9_ = 0;
					GArray* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
					_tmp9_ = i;
					_tmp10_ = xids;
					_tmp11_ = _tmp10_->len;
					_tmp7_ = ((guint) _tmp9_) < _tmp11_;
				} else {
					_tmp7_ = FALSE;
				}
				if (!_tmp7_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp16_ = window;
				if (_tmp16_ == NULL) {
					continue;
				}
				_tmp17_ = is_virtual;
				if (!_tmp17_) {
					WnckWindow* _tmp18_ = NULL;
					WnckWorkspace* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					_tmp18_ = window;
					_tmp19_ = workspace;
					_tmp20_ = wnck_window_is_on_workspace (_tmp18_, _tmp19_);
					if (_tmp20_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				} else {
					WnckWindow* _tmp21_ = NULL;
					WnckWorkspace* _tmp22_ = NULL;
					gboolean _tmp23_ = FALSE;
					_tmp21_ = window;
					_tmp22_ = workspace;
					_tmp23_ = wnck_window_is_in_viewport (_tmp21_, _tmp22_);
					if (_tmp23_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	g_return_if_fail (rect != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				WnckWindow* _tmp14_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp14_ = window;
				if (_tmp14_ != NULL) {
					WnckWindow* _tmp15_ = NULL;
					GdkRectangle _tmp16_ = {0};
					gint _tmp17_ = 0;
					GdkRectangle _tmp18_ = {0};
					gint _tmp19_ = 0;
					GdkRectangle _tmp20_ = {0};
					gint _tmp21_ = 0;
					GdkRectangle _tmp22_ = {0};
					gint _tmp23_ = 0;
					_tmp15_ = window;
					_tmp16_ = *rect;
					_tmp17_ = _tmp16_.x;
					_tmp18_ = *rect;
					_tmp19_ = _tmp18_.y;
					_tmp20_ = *rect;
					_tmp21_ = _tmp20_.width;
					_tmp22_ = *rect;
					_tmp23_ = _tmp22_.height;
					wnck_window_set_icon_geometry (_tmp15_, _tmp17_, _tmp19_, _tmp21_, _tmp23_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_close_all (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_skip_tasklist (_tmp16_);
					_tmp14_ = !_tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					WnckWindow* _tmp18_ = NULL;
					guint32 _tmp19_ = 0U;
					_tmp18_ = window;
					_tmp19_ = gtk_get_current_event_time ();
					wnck_window_close (_tmp18_, _tmp19_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_window (BamfWindow* window) {
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	g_return_if_fail (window != NULL);
	wnck_screen_get_default ();
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		return;
	}
	_tmp5_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp5_);
}


static void plank_services_windows_window_control_focus_window_by_xid (guint32 xid) {
	WnckWindow* w = NULL;
	guint32 _tmp0_ = 0U;
	WnckWindow* _tmp1_ = NULL;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	wnck_screen_get_default ();
	_tmp0_ = xid;
	_tmp1_ = wnck_window_get ((gulong) _tmp0_);
	w = _tmp1_;
	_tmp2_ = w;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = w;
	if (_tmp3_ == NULL) {
		return;
	}
	_tmp4_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp4_);
}


static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids) {
	gint result = 0;
	gint i = 0;
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			GArray* _tmp3_ = NULL;
			WnckWindow* window = NULL;
			GArray* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			guint32 _tmp9_ = 0U;
			WnckWindow* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			WnckWindow* _tmp12_ = NULL;
			if (!_tmp0_) {
				gint _tmp1_ = 0;
				_tmp1_ = i;
				i = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp3_ = xids;
			if (_tmp3_ != NULL) {
				gint _tmp4_ = 0;
				GArray* _tmp5_ = NULL;
				guint _tmp6_ = 0U;
				_tmp4_ = i;
				_tmp5_ = xids;
				_tmp6_ = _tmp5_->len;
				_tmp2_ = ((guint) _tmp4_) < _tmp6_;
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
			_tmp7_ = xids;
			_tmp8_ = i;
			_tmp9_ = g_array_index (_tmp7_, guint32, (guint) _tmp8_);
			_tmp10_ = wnck_window_get ((gulong) _tmp9_);
			window = _tmp10_;
			_tmp12_ = window;
			if (_tmp12_ != NULL) {
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				_tmp13_ = window;
				_tmp14_ = wnck_window_is_active (_tmp13_);
				_tmp11_ = _tmp14_;
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				break;
			}
		}
	}
	result = i;
	return result;
}


void plank_services_windows_window_control_focus_previous (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	GArray* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	guint32 _tmp16_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ - 1;
	} else {
		_tmp6_ = 0;
	}
	i = _tmp6_;
	_tmp11_ = i;
	if (_tmp11_ < 0) {
		GArray* _tmp12_ = NULL;
		guint _tmp13_ = 0U;
		_tmp12_ = xids;
		_tmp13_ = _tmp12_->len;
		i = ((gint) _tmp13_) - 1;
	}
	_tmp14_ = xids;
	_tmp15_ = i;
	_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp16_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_next (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	GArray* _tmp12_ = NULL;
	guint _tmp13_ = 0U;
	GArray* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	guint32 _tmp16_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ + 1;
	} else {
		_tmp6_ = 0;
	}
	i = _tmp6_;
	_tmp11_ = i;
	_tmp12_ = xids;
	_tmp13_ = _tmp12_->len;
	if (((guint) _tmp11_) == _tmp13_) {
		i = 0;
	}
	_tmp14_ = xids;
	_tmp15_ = i;
	_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp16_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_minimize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp2_ = FALSE;
				WnckWindow* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				_tmp3_ = window;
				_tmp4_ = wnck_window_is_minimized (_tmp3_);
				if (!_tmp4_) {
					WnckWindow* _tmp5_ = NULL;
					WnckWindow* _tmp6_ = NULL;
					WnckScreen* _tmp7_ = NULL;
					WnckWorkspace* _tmp8_ = NULL;
					gboolean _tmp9_ = FALSE;
					_tmp5_ = window;
					_tmp6_ = window;
					_tmp7_ = wnck_window_get_screen (_tmp6_);
					_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
					_tmp9_ = wnck_window_is_in_viewport (_tmp5_, _tmp8_);
					_tmp2_ = _tmp9_;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					WnckWindow* _tmp10_ = NULL;
					_tmp10_ = window;
					wnck_window_minimize (_tmp10_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_services_windows_window_control_restore (BamfApplication* app) {
	GList* stack = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	stack = _tmp1_;
	stack = g_list_reverse (stack);
	_tmp2_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp3_ = FALSE;
				WnckWindow* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				_tmp4_ = window;
				_tmp5_ = wnck_window_is_minimized (_tmp4_);
				if (_tmp5_) {
					WnckWindow* _tmp6_ = NULL;
					WnckWindow* _tmp7_ = NULL;
					WnckScreen* _tmp8_ = NULL;
					WnckWorkspace* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					_tmp6_ = window;
					_tmp7_ = window;
					_tmp8_ = wnck_window_get_screen (_tmp7_);
					_tmp9_ = wnck_screen_get_active_workspace (_tmp8_);
					_tmp10_ = wnck_window_is_in_viewport (_tmp6_, _tmp9_);
					_tmp3_ = _tmp10_;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					WnckWindow* _tmp11_ = NULL;
					guint32 _tmp12_ = 0U;
					_tmp11_ = window;
					_tmp12_ = gtk_get_current_event_time ();
					wnck_window_unminimize (_tmp11_, _tmp12_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_g_list_free0 (stack);
}


void plank_services_windows_window_control_maximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (!_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_maximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_services_windows_window_control_unmaximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_unmaximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


GList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app) {
	GList* result = NULL;
	GList* windows = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	GList* stack = NULL;
	WnckScreen* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	windows = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		result = windows;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp4_ = wnck_screen_get_default ();
	_tmp5_ = wnck_screen_get_windows_stacked (_tmp4_);
	stack = _tmp5_;
	_tmp6_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp6_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gint _tmp9_ = 0;
							GArray* _tmp10_ = NULL;
							guint _tmp11_ = 0U;
							GArray* _tmp12_ = NULL;
							gint _tmp13_ = 0;
							guint32 _tmp14_ = 0U;
							WnckWindow* _tmp15_ = NULL;
							gulong _tmp16_ = 0UL;
							if (!_tmp7_) {
								gint _tmp8_ = 0;
								_tmp8_ = j;
								j = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							_tmp9_ = j;
							_tmp10_ = xids;
							_tmp11_ = _tmp10_->len;
							if (!(((guint) _tmp9_) < _tmp11_)) {
								break;
							}
							_tmp12_ = xids;
							_tmp13_ = j;
							_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
							_tmp15_ = window;
							_tmp16_ = wnck_window_get_xid (_tmp15_);
							if (((gulong) _tmp14_) == _tmp16_) {
								WnckWindow* _tmp17_ = NULL;
								_tmp17_ = window;
								windows = g_list_append (windows, _tmp17_);
							}
						}
					}
				}
			}
		}
	}
	result = windows;
	_g_array_unref0 (xids);
	return result;
}


void plank_services_windows_window_control_smart_focus (BamfApplication* app) {
	GList* windows = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	GList* _tmp2_ = NULL;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	GList* _tmp25_ = NULL;
	GList* _tmp45_ = NULL;
	GList* _tmp68_ = NULL;
	GList* _tmp81_ = NULL;
	gconstpointer _tmp82_ = NULL;
	GList* _tmp83_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	windows = _tmp1_;
	not_in_viewport = TRUE;
	urgent = FALSE;
	_tmp2_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp3_ = FALSE;
				WnckWindow* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				WnckWindow* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				_tmp4_ = window;
				_tmp5_ = wnck_window_is_skip_tasklist (_tmp4_);
				if (!_tmp5_) {
					WnckWindow* _tmp6_ = NULL;
					WnckWindow* _tmp7_ = NULL;
					WnckScreen* _tmp8_ = NULL;
					WnckWorkspace* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					_tmp6_ = window;
					_tmp7_ = window;
					_tmp8_ = wnck_window_get_screen (_tmp7_);
					_tmp9_ = wnck_screen_get_active_workspace (_tmp8_);
					_tmp10_ = wnck_window_is_in_viewport (_tmp6_, _tmp9_);
					_tmp3_ = _tmp10_;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					not_in_viewport = FALSE;
				}
				_tmp11_ = window;
				_tmp12_ = wnck_window_needs_attention (_tmp11_);
				if (_tmp12_) {
					urgent = TRUE;
				}
			}
		}
	}
	_tmp14_ = not_in_viewport;
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp15_ = FALSE;
		_tmp15_ = urgent;
		_tmp13_ = _tmp15_;
	}
	if (_tmp13_) {
		GList* _tmp16_ = NULL;
		_tmp16_ = windows;
		{
			GList* window_collection = NULL;
			GList* window_it = NULL;
			window_collection = _tmp16_;
			for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
				WnckWindow* window = NULL;
				window = (WnckWindow*) window_it->data;
				{
					gboolean _tmp17_ = FALSE;
					gboolean _tmp18_ = FALSE;
					WnckWindow* _tmp21_ = NULL;
					gboolean _tmp22_ = FALSE;
					_tmp18_ = urgent;
					if (_tmp18_) {
						WnckWindow* _tmp19_ = NULL;
						gboolean _tmp20_ = FALSE;
						_tmp19_ = window;
						_tmp20_ = wnck_window_needs_attention (_tmp19_);
						_tmp17_ = !_tmp20_;
					} else {
						_tmp17_ = FALSE;
					}
					if (_tmp17_) {
						continue;
					}
					_tmp21_ = window;
					_tmp22_ = wnck_window_is_skip_tasklist (_tmp21_);
					if (!_tmp22_) {
						WnckWindow* _tmp23_ = NULL;
						GList* _tmp24_ = NULL;
						_tmp23_ = window;
						_tmp24_ = windows;
						plank_services_windows_window_control_intelligent_focus_off_viewport_window (_tmp23_, _tmp24_);
						_g_list_free0 (windows);
						return;
					}
				}
			}
		}
	}
	_tmp25_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp25_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp26_ = FALSE;
				WnckWindow* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
				_tmp27_ = window;
				_tmp28_ = wnck_window_is_minimized (_tmp27_);
				if (_tmp28_) {
					WnckWindow* _tmp29_ = NULL;
					WnckWindow* _tmp30_ = NULL;
					WnckScreen* _tmp31_ = NULL;
					WnckWorkspace* _tmp32_ = NULL;
					gboolean _tmp33_ = FALSE;
					_tmp29_ = window;
					_tmp30_ = window;
					_tmp31_ = wnck_window_get_screen (_tmp30_);
					_tmp32_ = wnck_screen_get_active_workspace (_tmp31_);
					_tmp33_ = wnck_window_is_in_viewport (_tmp29_, _tmp32_);
					_tmp26_ = _tmp33_;
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					GList* _tmp34_ = NULL;
					_tmp34_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp34_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp35_ = FALSE;
								WnckWindow* _tmp36_ = NULL;
								gboolean _tmp37_ = FALSE;
								_tmp36_ = w;
								_tmp37_ = wnck_window_is_minimized (_tmp36_);
								if (_tmp37_) {
									WnckWindow* _tmp38_ = NULL;
									WnckWindow* _tmp39_ = NULL;
									WnckScreen* _tmp40_ = NULL;
									WnckWorkspace* _tmp41_ = NULL;
									gboolean _tmp42_ = FALSE;
									_tmp38_ = w;
									_tmp39_ = w;
									_tmp40_ = wnck_window_get_screen (_tmp39_);
									_tmp41_ = wnck_screen_get_active_workspace (_tmp40_);
									_tmp42_ = wnck_window_is_in_viewport (_tmp38_, _tmp41_);
									_tmp35_ = _tmp42_;
								} else {
									_tmp35_ = FALSE;
								}
								if (_tmp35_) {
									WnckWindow* _tmp43_ = NULL;
									guint32 _tmp44_ = 0U;
									_tmp43_ = w;
									_tmp44_ = gtk_get_current_event_time ();
									wnck_window_unminimize (_tmp43_, _tmp44_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp45_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp45_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				WnckWindow* _tmp48_ = NULL;
				gboolean _tmp49_ = FALSE;
				_tmp48_ = window;
				_tmp49_ = wnck_window_is_active (_tmp48_);
				if (_tmp49_) {
					WnckWindow* _tmp50_ = NULL;
					WnckWindow* _tmp51_ = NULL;
					WnckScreen* _tmp52_ = NULL;
					WnckWorkspace* _tmp53_ = NULL;
					gboolean _tmp54_ = FALSE;
					_tmp50_ = window;
					_tmp51_ = window;
					_tmp52_ = wnck_window_get_screen (_tmp51_);
					_tmp53_ = wnck_screen_get_active_workspace (_tmp52_);
					_tmp54_ = wnck_window_is_in_viewport (_tmp50_, _tmp53_);
					_tmp47_ = _tmp54_;
				} else {
					_tmp47_ = FALSE;
				}
				if (_tmp47_) {
					_tmp46_ = TRUE;
				} else {
					WnckWindow* _tmp55_ = NULL;
					WnckScreen* _tmp56_ = NULL;
					WnckWindow* _tmp57_ = NULL;
					_tmp55_ = window;
					_tmp56_ = wnck_screen_get_default ();
					_tmp57_ = wnck_screen_get_active_window (_tmp56_);
					_tmp46_ = _tmp55_ == _tmp57_;
				}
				if (_tmp46_) {
					GList* _tmp58_ = NULL;
					_tmp58_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp58_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp59_ = FALSE;
								WnckWindow* _tmp60_ = NULL;
								gboolean _tmp61_ = FALSE;
								_tmp60_ = w;
								_tmp61_ = wnck_window_is_minimized (_tmp60_);
								if (!_tmp61_) {
									WnckWindow* _tmp62_ = NULL;
									WnckWindow* _tmp63_ = NULL;
									WnckScreen* _tmp64_ = NULL;
									WnckWorkspace* _tmp65_ = NULL;
									gboolean _tmp66_ = FALSE;
									_tmp62_ = w;
									_tmp63_ = w;
									_tmp64_ = wnck_window_get_screen (_tmp63_);
									_tmp65_ = wnck_screen_get_active_workspace (_tmp64_);
									_tmp66_ = wnck_window_is_in_viewport (_tmp62_, _tmp65_);
									_tmp59_ = _tmp66_;
								} else {
									_tmp59_ = FALSE;
								}
								if (_tmp59_) {
									WnckWindow* _tmp67_ = NULL;
									_tmp67_ = w;
									wnck_window_minimize (_tmp67_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp68_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp68_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp69_ = NULL;
				WnckWindow* _tmp70_ = NULL;
				WnckScreen* _tmp71_ = NULL;
				WnckWorkspace* _tmp72_ = NULL;
				gboolean _tmp73_ = FALSE;
				_tmp69_ = window;
				_tmp70_ = window;
				_tmp71_ = wnck_window_get_screen (_tmp70_);
				_tmp72_ = wnck_screen_get_active_workspace (_tmp71_);
				_tmp73_ = wnck_window_is_in_viewport (_tmp69_, _tmp72_);
				if (_tmp73_) {
					GList* _tmp74_ = NULL;
					_tmp74_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp74_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								WnckWindow* _tmp75_ = NULL;
								WnckWindow* _tmp76_ = NULL;
								WnckScreen* _tmp77_ = NULL;
								WnckWorkspace* _tmp78_ = NULL;
								gboolean _tmp79_ = FALSE;
								_tmp75_ = w;
								_tmp76_ = w;
								_tmp77_ = wnck_window_get_screen (_tmp76_);
								_tmp78_ = wnck_screen_get_active_workspace (_tmp77_);
								_tmp79_ = wnck_window_is_in_viewport (_tmp75_, _tmp78_);
								if (_tmp79_) {
									WnckWindow* _tmp80_ = NULL;
									_tmp80_ = w;
									plank_services_windows_window_control_center_and_focus_window (_tmp80_);
									g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp81_ = windows;
	_tmp82_ = g_list_nth_data (_tmp81_, (guint) 0);
	_tmp83_ = windows;
	plank_services_windows_window_control_intelligent_focus_off_viewport_window ((WnckWindow*) _tmp82_, _tmp83_);
	_g_list_free0 (windows);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean __lambda4_ (void) {
	gboolean result = FALSE;
	WnckWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	plank_services_windows_window_control_delayed_focus_timer = (guint) 0;
	_tmp0_ = plank_services_windows_window_control_delayed_focus_window;
	_tmp1_ = gtk_get_current_event_time ();
	wnck_window_activate (_tmp0_, _tmp1_);
	_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
	plank_services_windows_window_control_delayed_focus_window = NULL;
	result = FALSE;
	return result;
}


static gboolean ___lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda4_ ();
	return result;
}


static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows) {
	GList* _tmp0_ = NULL;
	WnckWindow* _tmp8_ = NULL;
	GList* _tmp9_ = NULL;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	WnckWindow* _tmp13_ = NULL;
	WnckWindow* _tmp14_ = NULL;
	guint _tmp15_ = 0U;
	g_return_if_fail (targetWindow != NULL);
	additional_windows = g_list_reverse (additional_windows);
	_tmp0_ = additional_windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp1_ = FALSE;
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_minimized (_tmp2_);
				if (!_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					WnckWindow* _tmp5_ = NULL;
					gboolean _tmp6_ = FALSE;
					_tmp4_ = targetWindow;
					_tmp5_ = window;
					_tmp6_ = plank_services_windows_window_control_windows_share_viewport (_tmp4_, _tmp5_);
					_tmp1_ = _tmp6_;
				} else {
					_tmp1_ = FALSE;
				}
				if (_tmp1_) {
					WnckWindow* _tmp7_ = NULL;
					_tmp7_ = window;
					plank_services_windows_window_control_center_and_focus_window (_tmp7_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_tmp8_ = targetWindow;
	plank_services_windows_window_control_center_and_focus_window (_tmp8_);
	_tmp9_ = additional_windows;
	_tmp10_ = g_list_length (_tmp9_);
	if (_tmp10_ <= ((guint) 1)) {
		return;
	}
	_tmp11_ = plank_services_windows_window_control_delayed_focus_timer;
	if (_tmp11_ > ((guint) 0)) {
		guint _tmp12_ = 0U;
		_tmp12_ = plank_services_windows_window_control_delayed_focus_timer;
		g_source_remove (_tmp12_);
	}
	_tmp13_ = targetWindow;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	_g_object_unref0 (plank_services_windows_window_control_delayed_focus_window);
	plank_services_windows_window_control_delayed_focus_window = _tmp14_;
	_tmp15_ = gdk_threads_add_timeout (PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda4__gsource_func, NULL);
	plank_services_windows_window_control_delayed_focus_timer = _tmp15_;
}


static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_ = NULL;
	WnckWorkspace* wksp = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWorkspace* _tmp4_ = NULL;
	WnckWorkspace* _tmp5_ = NULL;
	WnckWorkspace* _tmp8_ = NULL;
	GdkRectangle firstGeo = {0};
	GdkRectangle secondGeo = {0};
	WnckWindow* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	WnckWindow* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	WnckWorkspace* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	WnckWorkspace* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	WnckWorkspace* _tmp26_ = NULL;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	WnckWorkspace* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	gint viewportWidth = 0;
	WnckWindow* _tmp31_ = NULL;
	WnckScreen* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	gint viewportHeight = 0;
	WnckWindow* _tmp34_ = NULL;
	WnckScreen* _tmp35_ = NULL;
	gint _tmp36_ = 0;
	gint firstViewportX = 0;
	GdkRectangle _tmp37_ = {0};
	gint _tmp38_ = 0;
	GdkRectangle _tmp39_ = {0};
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint firstViewportY = 0;
	GdkRectangle _tmp43_ = {0};
	gint _tmp44_ = 0;
	GdkRectangle _tmp45_ = {0};
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	GdkRectangle viewpRect = {0};
	gint _tmp49_ = 0;
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	GdkRectangle _tmp53_ = {0};
	gboolean _tmp54_ = FALSE;
	_tmp1_ = first;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		WnckWindow* _tmp2_ = NULL;
		_tmp2_ = second;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = first;
	_tmp4_ = wnck_window_get_workspace (_tmp3_);
	wksp = _tmp4_;
	_tmp5_ = wksp;
	if (_tmp5_ == NULL) {
		WnckWindow* _tmp6_ = NULL;
		WnckWorkspace* _tmp7_ = NULL;
		_tmp6_ = second;
		_tmp7_ = wnck_window_get_workspace (_tmp6_);
		wksp = _tmp7_;
	}
	_tmp8_ = wksp;
	if (_tmp8_ == NULL) {
		result = FALSE;
		return result;
	}
	memset (&firstGeo, 0, sizeof (GdkRectangle));
	memset (&secondGeo, 0, sizeof (GdkRectangle));
	_tmp9_ = first;
	wnck_window_get_geometry (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
	firstGeo.x = _tmp10_;
	firstGeo.y = _tmp11_;
	firstGeo.width = _tmp12_;
	firstGeo.height = _tmp13_;
	_tmp14_ = second;
	wnck_window_get_geometry (_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_);
	secondGeo.x = _tmp15_;
	secondGeo.y = _tmp16_;
	secondGeo.width = _tmp17_;
	secondGeo.height = _tmp18_;
	_tmp19_ = firstGeo.x;
	_tmp20_ = wksp;
	_tmp21_ = wnck_workspace_get_viewport_x (_tmp20_);
	firstGeo.x = _tmp19_ + _tmp21_;
	_tmp22_ = firstGeo.y;
	_tmp23_ = wksp;
	_tmp24_ = wnck_workspace_get_viewport_y (_tmp23_);
	firstGeo.y = _tmp22_ + _tmp24_;
	_tmp25_ = secondGeo.x;
	_tmp26_ = wksp;
	_tmp27_ = wnck_workspace_get_viewport_x (_tmp26_);
	secondGeo.x = _tmp25_ + _tmp27_;
	_tmp28_ = secondGeo.y;
	_tmp29_ = wksp;
	_tmp30_ = wnck_workspace_get_viewport_y (_tmp29_);
	secondGeo.y = _tmp28_ + _tmp30_;
	_tmp31_ = first;
	_tmp32_ = wnck_window_get_screen (_tmp31_);
	_tmp33_ = wnck_screen_get_width (_tmp32_);
	viewportWidth = _tmp33_;
	_tmp34_ = first;
	_tmp35_ = wnck_window_get_screen (_tmp34_);
	_tmp36_ = wnck_screen_get_height (_tmp35_);
	viewportHeight = _tmp36_;
	_tmp37_ = firstGeo;
	_tmp38_ = _tmp37_.x;
	_tmp39_ = firstGeo;
	_tmp40_ = _tmp39_.width;
	_tmp41_ = viewportWidth;
	_tmp42_ = viewportWidth;
	firstViewportX = ((_tmp38_ + (_tmp40_ / 2)) / _tmp41_) * _tmp42_;
	_tmp43_ = firstGeo;
	_tmp44_ = _tmp43_.y;
	_tmp45_ = firstGeo;
	_tmp46_ = _tmp45_.height;
	_tmp47_ = viewportHeight;
	_tmp48_ = viewportHeight;
	firstViewportY = ((_tmp44_ + (_tmp46_ / 2)) / _tmp47_) * _tmp48_;
	memset (&viewpRect, 0, sizeof (GdkRectangle));
	_tmp49_ = firstViewportX;
	viewpRect.x = _tmp49_;
	_tmp50_ = firstViewportY;
	viewpRect.y = _tmp50_;
	_tmp51_ = viewportWidth;
	viewpRect.width = _tmp51_;
	_tmp52_ = viewportHeight;
	viewpRect.height = _tmp52_;
	_tmp53_ = secondGeo;
	_tmp54_ = gdk_rectangle_intersect (&viewpRect, &_tmp53_, NULL);
	result = _tmp54_;
	return result;
}


static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w) {
	guint32 time = 0U;
	guint32 _tmp0_ = 0U;
	WnckWorkspace* workspace = NULL;
	WnckWindow* _tmp1_ = NULL;
	WnckWorkspace* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	WnckWorkspace* _tmp4_ = NULL;
	WnckWindow* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	WnckWindow* _tmp15_ = NULL;
	guint32 _tmp16_ = 0U;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_get_current_event_time ();
	time = _tmp0_;
	_tmp1_ = w;
	_tmp2_ = wnck_window_get_workspace (_tmp1_);
	workspace = _tmp2_;
	_tmp4_ = workspace;
	if (_tmp4_ != NULL) {
		WnckWorkspace* _tmp5_ = NULL;
		WnckWindow* _tmp6_ = NULL;
		WnckScreen* _tmp7_ = NULL;
		WnckWorkspace* _tmp8_ = NULL;
		_tmp5_ = workspace;
		_tmp6_ = w;
		_tmp7_ = wnck_window_get_screen (_tmp6_);
		_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
		_tmp3_ = _tmp5_ != _tmp8_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		WnckWorkspace* _tmp9_ = NULL;
		guint32 _tmp10_ = 0U;
		_tmp9_ = workspace;
		_tmp10_ = time;
		wnck_workspace_activate (_tmp9_, _tmp10_);
	}
	_tmp11_ = w;
	_tmp12_ = wnck_window_is_minimized (_tmp11_);
	if (_tmp12_) {
		WnckWindow* _tmp13_ = NULL;
		guint32 _tmp14_ = 0U;
		_tmp13_ = w;
		_tmp14_ = time;
		wnck_window_unminimize (_tmp13_, _tmp14_);
	}
	_tmp15_ = w;
	_tmp16_ = time;
	wnck_window_activate_transient (_tmp15_, _tmp16_);
}


void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result) {
	GdkRectangle geo = {0};
	WnckWindow* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_if_fail (w != NULL);
	memset (&geo, 0, sizeof (GdkRectangle));
	_tmp0_ = w;
	wnck_window_get_geometry (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	geo.x = _tmp1_;
	geo.y = _tmp2_;
	geo.width = _tmp3_;
	geo.height = _tmp4_;
	*result = geo;
	return;
}


static void plank_services_windows_window_control_class_init (PlankServicesWindowsWindowControlClass * klass) {
	plank_services_windows_window_control_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_services_windows_window_control_finalize;
}


static void plank_services_windows_window_control_instance_init (PlankServicesWindowsWindowControl * self) {
}


static void plank_services_windows_window_control_finalize (GObject* obj) {
	PlankServicesWindowsWindowControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl);
	G_OBJECT_CLASS (plank_services_windows_window_control_parent_class)->finalize (obj);
}


GType plank_services_windows_window_control_get_type (void) {
	static volatile gsize plank_services_windows_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesWindowsWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_windows_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesWindowsWindowControl), 0, (GInstanceInitFunc) plank_services_windows_window_control_instance_init, NULL };
		GType plank_services_windows_window_control_type_id;
		plank_services_windows_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesWindowsWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_windows_window_control_type_id__volatile, plank_services_windows_window_control_type_id);
	}
	return plank_services_windows_window_control_type_id__volatile;
}



